package com.chinaitop.depot.storage.service.impl;

import com.alibaba.fastjson.JSONObject;

import com.chinaitop.depot.storage.mapper.ClearanceConfirmationMapper;
import com.chinaitop.depot.storage.model.ClearanceConfirmation;
import com.chinaitop.depot.storage.service.ClearanceConfirmationService;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.sun.javafx.collections.MappingChange;
import org.apache.commons.lang.ObjectUtils;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

@Service
public class ClearanceConfirmationServiceImpl implements ClearanceConfirmationService {

    @Resource
    private ClearanceConfirmationMapper ClearanceConfirmationMapper;

//    @Resource
//    private BasicStorehouseService basicStorehouseService;




    @Override
    public List<ClearanceConfirmation> getList(Map<String, Object> map) {
        return ClearanceConfirmationMapper.getCleConList(map);
    }

    @Override
    public ClearanceConfirmation findByCleCon(Integer id) {
        return ClearanceConfirmationMapper.findByCleCon(id);
    }

    @Override
    public Map<String, Object> saveOrUpdate(HttpServletRequest request, String clearanceConfirmationJson, String userInfo) throws Exception {
        Map<String, Object> modelMap = new HashMap<String, Object>();
        JSONObject user = null;
        JSONObject org = null;
        Integer orgId = null;
        String userName = "";
        Map<String, Object> modelMap1 = new HashMap<String, Object>();

        if (null != userInfo && !"".equals(userInfo)) {
            user = JSONObject.parseObject(userInfo);
            orgId = Integer.parseInt(user.get("orgId") == null?"":user.get("orgId").toString());
            userName = user.get("username") == null?"":user.get("username").toString();
            modelMap1.put("orgId", orgId);
        }

        //获取单位信息
        String orgInfo = ObjectUtils.toString(request.getSession().getAttribute("orgInfo"),"");
        String dwbm = "";
        String ajbm ="";
        if (null != orgInfo && !"".equals(orgInfo)) {
            org = JSONObject.parseObject(orgInfo);
            dwbm = org.get("creditCode") == null?"":org.get("creditCode").toString();
        }

        Date date = new Date();
        // JSON字符串转对象
        ObjectMapper mapper = new ObjectMapper();
        ClearanceConfirmation ClearanceConfirmation = (ClearanceConfirmation) mapper.readValue(clearanceConfirmationJson, ClearanceConfirmation.class);
        if (ClearanceConfirmation.getId() == null) {
            modelMap1.put("cqqrdh",ClearanceConfirmation.getCqqrdh());
            List<ClearanceConfirmation> clearanceConfirmation = ClearanceConfirmationMapper.findByCleConList(modelMap1);
            if(clearanceConfirmation.size()>0){
                modelMap.put("message", "出清确认单号已经存在");
                return modelMap;
            }
            ClearanceConfirmation.setCreatename(userName);
            ClearanceConfirmation.setCreatedate(date);
            ClearanceConfirmation.setUpdatename(userName);
            ClearanceConfirmation.setUpdatedate(date);
            ClearanceConfirmation.setZhgxsj(date);
            ClearanceConfirmation.setCzbz("i");
            ClearanceConfirmationMapper.insert(ClearanceConfirmation);
        } else {
            ClearanceConfirmation.setUpdatename(userName);
            ClearanceConfirmation.setUpdatedate(date);
            ClearanceConfirmation.setZhgxsj(date);
            ClearanceConfirmation.setCzbz("u");
            ClearanceConfirmationMapper.updateByPrimaryKey(ClearanceConfirmation);
        }
        modelMap.put("status", "success");

        return modelMap;
    }


    public void updateBasicStorehouse(ClearanceConfirmation ClearanceConfirmation){
        ClearanceConfirmationMapper.updateByPrimaryKey(ClearanceConfirmation);
    }
}
